<?php

namespace App\Filament\Resources;

use App\Filament\Exports\MachineExporter;
use App\Filament\Imports\MachineImporter;
use App\Filament\Resources\MachineResource\Pages;
use App\Filament\Resources\MachineResource\RelationManagers;
use App\Models\Line;
use App\Models\Machine;
use App\Models\Plant;
use App\Models\WorkGroupMaster;
use Filament\Facades\Filament;
use Filament\Forms;
use Filament\Forms\Form;
use Filament\Forms\Get;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Filament\Tables\Actions\ImportAction;
use Filament\Tables\Actions\ExportAction;
use Illuminate\Validation\Rule;
use Str;

class MachineResource extends Resource
{
    protected static ?string $model = Machine::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Master Entries';

    protected static ?int $navigationSort = 12;

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\Select::make('plant_id')
                    ->label('Plant')
                    ->relationship('plant', 'name')
                    ->required()
                    ->reactive()
                    ->options(function (callable $get) {
                        $userHas = Filament::auth()->user()->plant_id;
                        return ($userHas && strlen($userHas) > 0) ? Plant::where('id', $userHas)->pluck('name', 'id')->toArray() : Plant::pluck('name', 'id')->toArray();
                    })
                    ->default(function () {
                        return optional(Machine::latest()->first())->plant_id;
                    })
                    ->disabled(fn (Get $get) => !empty($get('id')))
                    ->afterStateUpdated(function ($state, callable $set, callable $get) {
                        $plantId = $get('plant_id');
                        if (!$plantId) {
                            $set('mPlantError', 'Please select a plant first.');
                            $set('line_id', null);
                            $set('work_group_master_id', null);
                            return;
                        }
                        else
                        {
                            $set('mPlantError', null);
                        }
                    })
                    ->extraAttributes(fn ($get) => [
                        'class' => $get('mPlantError') ? 'border-red-500' : '',
                    ])
                    ->hint(fn ($get) => $get('mPlantError') ? $get('mPlantError') : null)
                    ->hintColor('danger'),
                Forms\Components\Select::make('line_id')
                    ->label('Line')
                    ->relationship('line', 'name')
                    ->required()
                    ->reactive()
                    ->options(function (callable $get) {
                        if (!$get('plant_id')) {
                            return [];
                        }

                        return Line::where('plant_id', $get('plant_id'))->where('no_of_operation', '>', 0)->pluck('name', 'id')->toArray();
                    })
                    ->default(function () {
                        return optional(Machine::latest()->first())->line_id;
                    })
                    ->disabled(fn (Get $get) => !empty($get('id')))
                    ->afterStateUpdated(function ($state, callable $set, callable $get) {
                        $lineId = $get('line_id');
                        if (!$lineId) {
                            $set('mLineError', 'Please select a line first.');
                            $set('work_group_master_id', null);
                            return;
                        }
                        else
                        {
                            // $grpWrkCnr = Line::find($lineId)->group_work_center;
                            // if (!$grpWrkCnr || Str::length($grpWrkCnr) < 1)
                            // {
                            //     $set('mLineError', 'Please select a group work center line.');
                            //     $set('line_id', null);
                            //     return;
                            // }
                            $set('mLineError', null);
                        }
                    })
                    ->extraAttributes(fn ($get) => [
                        'class' => $get('mLineError') ? 'border-red-500' : '',
                    ])
                    ->hint(fn ($get) => $get('mLineError') ? $get('mLineError') : null)
                    ->hintColor('danger'),
                Forms\Components\Select::make('work_group_master_id')
                    ->label('Group Work Center')
                    ->relationship('workGroupMaster', 'name')
                    ->required()
                    ->reactive()
                    ->options(function (callable $get) {
                        if (!$get('plant_id') || !$get('line_id')) {
                            return [];
                        }

                        $line = Line::find($get('line_id'));
                        $workGroupIds = [];
                        for ($i = 1; $i <= $line->no_of_operation; $i++) {
                            $column = "work_group{$i}_id";
                            if (!empty($line->$column)) {
                                $workGroupIds[] = $line->$column;
                            }
                        }

                        return WorkGroupMaster::where('plant_id', $get('plant_id'))->whereIn('id', $workGroupIds)->pluck('name', 'id')->toArray();
                    })
                    ->default(function () {
                        return optional(Machine::latest()->first())->work_group_master_id;
                    })
                    ->disabled(fn (Get $get) => !empty($get('id')))
                    ->afterStateUpdated(function ($state, callable $set, callable $get) {
                        $lineId = $get('line_id');
                        if (!$lineId) {
                            $set('mGroupWorkError', 'Please select a line first.');
                            return;
                        }
                        else
                        {
                            // $grpWrkCnr = Line::find($lineId)->group_work_center;
                            // if (!$grpWrkCnr || Str::length($grpWrkCnr) < 1)
                            // {
                            //     $set('mGroupWorkError', 'Please select a group work center line.');
                            //     $set('line_id', null);
                            //     return;
                            // }
                            $set('mGroupWorkError', null);
                        }
                    })
                    ->extraAttributes(fn ($get) => [
                        'class' => $get('mGroupWorkError') ? 'border-red-500' : '',
                    ])
                    ->hint(fn ($get) => $get('mGroupWorkError') ? $get('mGroupWorkError') : null)
                    ->hintColor('danger'),
                Forms\Components\TextInput::make('name')
                    ->label('Name')
                    ->minLength(5)
                    ->placeholder('Scan the valid Machine Name')
                    ->required()
                    ->rule(function (callable $get) {
                        return Rule::unique('machines', 'name')
                            //->where('line_id', $get('line_id'))
                            ->where('plant_id', $get('plant_id'))
                            ->ignore($get('id')); // Ignore current record during updates
                    }),
                Forms\Components\TextInput::make('work_center')
                    ->label('Work Center')
                    ->minLength(6)
                    ->placeholder('Scan the valid Work Center')
                    ->required()
                    ->rule(function (callable $get) {
                        return Rule::unique('machines', 'work_center')
                            ->where('plant_id', $get('plant_id'))
                            ->ignore($get('id')); // Ignore current record during updates
                    }),
                Forms\Components\TextInput::make('id')
                    ->hidden()
                    ->readOnly(),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;
                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->searchable(),
                Tables\Columns\TextColumn::make('line.name')
                    ->label('Line')
                    ->alignCenter()
                    ->searchable(),
                Tables\Columns\TextColumn::make('name')
                    ->label('Name')
                    ->alignCenter()
                    ->searchable(),
                Tables\Columns\TextColumn::make('work_center')
                    ->label('Work Center')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('workGroupMaster.name')
                    ->label('Work Group Center')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable(),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable(),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
            ])
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->label('Import Machines')
                    ->color('warning')
                    ->importer(MachineImporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view import machine');
                    }),
                ExportAction::make()
                    ->label('Export Machines')
                    ->color('warning')
                    ->exporter(MachineExporter::class)
                    ->visible(function() {
                        return Filament::auth()->user()->can('view export machine');
                    }),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListMachines::route('/'),
            'create' => Pages\CreateMachine::route('/create'),
            'view' => Pages\ViewMachine::route('/{record}'),
            'edit' => Pages\EditMachine::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
